%global         package_version 1.0.0_master
%global         package_name ovirt-fast-forward-upgrade

%if 0%{?fedora}
%global         with_python3 1
%global         __python_bin %{__python3}
%global         __python_sitelib %{python3_sitelib}
%else
%global         __python_bin %{__python2}
%global         __python_sitelib %{python2_sitelib}
%endif

# Skips check since rhel default repos lack flake8
%if ! 0%{?rhel}
%{!?with_check:%global with_check 1}
%else
%{!?with_check:%global with_check 0}
%endif

# Default to skipping autoreconf.  Distros can change just this one line
# (or provide a command-line override) if they backport any patches that
# touch configure.ac or Makefile.am.
%{!?enable_autotools:%global enable_autotools 0}

%global modname ovirt-fast-forward-upgrade

Name:          ovirt-fast-forward-upgrade
Version:       1.0.0
Release:       12%{?release_suffix}%{?dist}
Summary:       Upgrade tool for RHV environments
License:       GPLv2
Group:         System Environment/Libraries
URL:           http://www.ovirt.org

Source0:       http://resources.ovirt.org/pub/ovirt-master-snapshot/src/%{package_name}/%{package_name}-%{package_version}.tar.gz

Patch0:  0001-ovirt-fast-forward-upgrade-channels-for-4.3-BETA.patch
Patch1:  0002-ovirt-fast-forward-upgrade-warning-for-4.3-upgrades.patch
Patch2: 0003-ovirt-fast-forward-upgrade-update-jb-eap-channels.patch
Patch3: 0004-ovirt-fast-forward-upgrade-support-hosted-engine-HE.patch
Patch4: 0005-ovirt-fast-forward-upgrade-ignore-ctrl-c-and-ctrl-z.patch
Patch5: 0006-ovirt-fast-forward-upgrade-add-missing-self.patch
Patch6: 0007-E713-test-for-membership-should-be-not-in.patch
Patch7: 0008-ovirt-fast-forward-upgrade-replace-raw_input.patch
Patch8: 0009-ovirt-fast-forward-upgrade-Add-welcome-message.patch
Patch9: 0010-ovirt-fast-forward-upgrade-detect-unsupported-cluste.patch
Patch10: 0011-ovirt-fast-forward-upgrade-compatibility-improvement.patch
Patch11: 0012-Ask-for-the-hosts-upgrade-after-the-end.patch
Patch12: 0013-spec-remove-engine-setup-requirements.patch
Patch13: 0014-channels-remove-beta-channels-for-4.3-and-add-GA.patch
Patch14: 0015-channels-fix-channels-for-4.3.patch

BuildArch:     noarch

Requires: subscription-manager
Requires: yum
Requires: rpm-python
Requires: engine-db-query

BuildRequires: python2-devel
BuildRequires: python-setuptools

%if 0%{?with_check}
BuildRequires: python-tools
BuildRequires: python-flake8
%endif

# Autotools BuildRequires
%if 0%{?enable_autotools}
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: gettext-devel
BuildRequires: libtool
%endif

%{!?_licensedir:%global license %%doc}

%description
A tool to help users upgrade RHV environments

%prep
%setup -q -n %{name}-%{package_version}

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1

%build
%if 0%{?enable_autotools}
autoreconf -if
%endif

%configure \
	PYTHON="%{__python_bin}"
make %{?_smp_mflags}

%install
make %{?_smp_mflags} install DESTDIR="%{buildroot}"

%post
ln -sf %{_sbindir}/ovirt-fast-forward-upgrade %{_sbindir}/engine-fast-forward-upgrade
ln -sf %{_mandir}/man8/ovirt-fast-forward-upgrade.* %{_mandir}/man8/engine-fast-forward-upgrade.8.gz

%files
%doc AUTHORS
%license LICENSE
%{_sbindir}/ovirt-fast-forward-upgrade
%{_mandir}/man8/*

%changelog
* Thu Apr 11 2019 Douglas Schilling Landgraf <dougsland@redhat.com> 1.0.0-12
- Remove beta channels

* Wed Apr 10 2019 Douglas Schilling Landgraf <dougsland@redhat.com> 1.0.0-11
- Ask for the hosts upgrade after the end
- spec: remove engine setup requirements

* Thu Apr 04 2019 Douglas Schilling Landgraf <dougsland@redhat.com> 1.0.0-8
- ovirt-fast-forward-upgrade: compatibility improvements
- ovirt-fast-forward-upgrade: detect unsupported clusters
- ovirt-fast-forward-upgrade: Add welcome message
- ovirt-fast-forward-upgrade: replace raw_input
- E713 test for membership should be 'not in'
- ovirt-fast-forward-upgrade: add missing self
- ovirt-fast-forward-upgrade: ignore ctrl-c and ctrl-z
- ovirt-fast-forward-upgrade:: support hosted-engine (HE)
- ovirt-fast-forward-upgrade: update jb-eap channels

* Tue Feb 05 2019 Douglas Schilling Landgraf <dougsland@redhat.com> 1.0.0-7
- ovirt-fast-forward-upgrade: warning for 4.3 upgrades

* Mon Jan 21 2019 Douglas Schilling Landgraf <dougsland@redhat.com> 1.0.0-6
- Add 4.3 beta channels

* Thu Oct 25 2018 Douglas Schilling Landgraf <dougsland@redhat.com> 1.0.0-4
- 1.0.0-4 build

* Fri Dec 08 2017 Douglas Schilling Landgraf <dougsland@redhat.com> 1.0.0-3
- Release 1.0.0-3
- hyper-upgrade: Enable beta channels for 4.2
- hyper-upgrade: Single message after upgrade is done
- hyper-upgrade: remove --upgrade-to-rhv option
- --help: keep 80 chars length
- ovirt-fast-forward-upgrade: Enable/Disable with single cmd
- ovirt-fast-forward-upgrade: fix log typo

* Fri Dec 08 2017 Douglas Schilling Landgraf <dougsland@redhat.com> 1.0.0-2
- Release 1.0.0-2

* Wed Nov 22 2017 Douglas Schilling Landgraf <dougsland@redhat.com> 1.0.0-1
- Release 1.0.0-1

* Thu Oct 19 2017 Douglas Schilling Landgraf <dougsland@redhat.com> 1.0.0-0
- Initial take
